Character character;
Object[] objects;
Enemy[] enemies;
int timer;
float health_percentage;
boolean game_over;
boolean started_game = false;


void setup() {
  size(1000, 720);
  character = new Character(500, 500, 60);
  objects = new Object[30];
  enemies = new Enemy[30];
  for (int i = 0; i<30; i++) {
    objects[i] = new Object(random(275, 725), random(-5200, 695), 30); //so that as the negative is updated to positive, the illusion of movement is created
  }
  enemies[0] = new Enemy(450, 450, 60);
  for (int i = 1; i<30; i++) {
    enemies[i] = new Enemy(random(275, 725), random(-5200, 695), 60);
  }
  timer = 65;
  health_percentage = 100;
  game_over = false;
  if (started_game == false)
    startScreen();
}

void draw() {

  //placeholder backgrounds
  background(139, 138, 147);
  noStroke();
  fill(98, 222, 92);
  rect(0, 0, 250, 720);
  fill(0, 0, 0);
  rect(750, 0, 1000, 720);

  //displaying the objects and character
  for (int i = 0; i<30; i++) {
    if (objects[i]!=null) {
      if (dist(character.x, character.y, objects[i].x, objects[i].y) <= character.r + objects[i].r) {
        objects[i] = null;
        if (character.health+2 < 150) {
          character.health+=2;
        } else {
          while (character.health < 150) {
            character.health+=1;
          }
        }
        //object sounds
      }
    }

    if (enemies[i]!=null) {
      if (dist(character.x, character.y, enemies[i].x, enemies[i].y) <= character.r + enemies[i].r) {
        character.health -= 10;
        timer -= 1;
        enemies[i] = null;
        //hit sounds
      }
    }

    if (enemies[i]!=null)
      enemies[i].display();

    if (objects[i]!=null)
      objects[i].display();
  }

  fill(255, 255, 255);
  textSize(20);
  text("Health: ", 780, 100);
  health_percentage = int((character.health * 100) / 150.0 * 100) / 100.0;
  noStroke();

  //To change colour depending on health
  if (health_percentage >= 50)
    fill(0, 250, 0);
  else if (health_percentage >= 20)
    fill(255, 255, 0);
  else
  fill(255, 0, 0);
  rect(780, 125, character.health, 25);
  noFill();
  strokeWeight(5);
  stroke(255, 255, 255);
  rect(780, 125, 150, 25);
  fill(255, 255, 255);
  textSize(15);
  text(str(health_percentage) + "%", 935, 140);

  //To display timer
  fill(255);
  textSize(20);
  text("Time: ", 780, 200);
  textSize(25);
  text(str(timer), 780, 225);
  character.display();
}

void startScreen() {
  background(0);
}

void mouseCLicked() {
  if(started_game == false)
    started_game = true;
   else
     frameCount = -1;
}
//for movement when the left or right keys are pressed
void keyPressed() {
  if (keyCode == LEFT)
    character.pressed_left = true;
  else if (keyCode == RIGHT)
    character.pressed_right = true;
}
void keyReleased() {
  if (keyCode == LEFT)
    character.pressed_left = false;
  else if (keyCode == RIGHT)
    character.pressed_right = false;
}
